Index: /trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Core;
@@ -38,5 +39,5 @@
     }
 
-    protected override ScopeList Select(ScopeList scopes) {
+    protected override IScope[] Select(List<IScope> scopes) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       bool copy = CopySelectedParameter.Value.Value;
@@ -44,5 +45,5 @@
       bool maximization = MaximizationParameter.ActualValue.Value;
       ItemArray<DoubleData> qualities = QualityParameter.ActualValue;
-      ScopeList selected = new ScopeList();
+      IScope[] selected = new IScope[count];
 
       // create a list for each scope that contains the scope's index in the original scope list and its lots
@@ -64,7 +65,7 @@
         }
         if (copy)
-          selected.Add((IScope)scopes[list[index].index].Clone());
+          selected[i] = (IScope)scopes[list[index].index].Clone();
         else {
-          selected.Add(scopes[list[index].index]);
+          selected[i] = scopes[list[index].index];
           scopes.RemoveAt(list[index].index);
           lotSum -= list[index].lots;
Index: /trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,6 +34,6 @@
     public MergingReducer() : base() { }
 
-    protected override ScopeList Reduce(ScopeList scopes) {
-      ScopeList reduced = new ScopeList();
+    protected override List<IScope> Reduce(List<IScope> scopes) {
+      List<IScope> reduced = new List<IScope>();
       for (int i = 0; i < scopes.Count; i++)
         reduced.AddRange(scopes[i].SubScopes);
Index: /trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs	(revision 2830)
@@ -51,5 +51,5 @@
     }
 
-    protected override ScopeList Select(ScopeList scopes) {
+    protected override IScope[] Select(List<IScope> scopes) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       bool copy = CopySelectedParameter.Value.Value;
@@ -57,5 +57,5 @@
       bool maximization = MaximizationParameter.ActualValue.Value;
       bool windowing = WindowingParameter.Value.Value;
-      ScopeList selected = new ScopeList();
+      IScope[] selected = new IScope[count];
 
       // prepare qualities for proportional selection
@@ -91,7 +91,7 @@
         }
         if (copy)
-          selected.Add((IScope)scopes[index].Clone());
+          selected[i] = (IScope)scopes[index].Clone();
         else {
-          selected.Add(scopes[index]);
+          selected[i] = scopes[index];
           scopes.RemoveAt(index);
           qualitySum -= list[index];
Index: /trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/RandomSelector.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,16 +34,16 @@
     public RandomSelector() : base() { }
 
-    protected override ScopeList Select(ScopeList scopes) {
+    protected override IScope[] Select(List<IScope> scopes) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       bool copy = CopySelectedParameter.Value.Value;
       IRandom random = RandomParameter.ActualValue;
-      ScopeList selected = new ScopeList();
+      IScope[] selected = new IScope[count];
 
       for (int i = 0; i < count; i++) {
         if (copy)
-          selected.Add((IScope)scopes[random.Next(scopes.Count)].Clone());
+          selected[i] = (IScope)scopes[random.Next(scopes.Count)].Clone();
         else {
           int index = random.Next(scopes.Count);
-          selected.Add(scopes[index]);
+          selected[i] = scopes[index];
           scopes.RemoveAt(index);
         }
Index: /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Operators;
@@ -46,6 +47,6 @@
 
     public sealed override IExecutionSequence Apply() {
-      ScopeList scopes = new ScopeList(CurrentScope.SubScopes);
-      ScopeList reduced = Reduce(scopes);
+      List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
+      List<IScope> reduced = Reduce(scopes);
 
       CurrentScope.SubScopes.Clear();
@@ -55,5 +56,5 @@
     }
 
-    protected abstract ScopeList Reduce(ScopeList scopes);
+    protected abstract List<IScope> Reduce(List<IScope> scopes);
   }
 }
Index: /trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,6 +34,6 @@
     public RightReducer() : base() { }
 
-    protected override ScopeList Reduce(ScopeList scopes) {
-      ScopeList reduced = new ScopeList();
+    protected override List<IScope> Reduce(List<IScope> scopes) {
+      List<IScope> reduced = new List<IScope>();
       if (scopes.Count > 0) reduced.AddRange(scopes[scopes.Count - 1].SubScopes);
       return reduced;
Index: /trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/RightSelector.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,17 +34,17 @@
     public RightSelector() : base() { }
 
-    protected override ScopeList Select(ScopeList scopes) {
+    protected override IScope[] Select(List<IScope> scopes) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       bool copy = CopySelectedParameter.Value.Value;
-      ScopeList selected = new ScopeList();
+      IScope[] selected = new IScope[count];
 
       int j = scopes.Count - 1;
       for (int i = 0; i < count; i++) {
         if (copy) {
-          selected.Add((IScope)scopes[j].Clone());
+          selected[i] = (IScope)scopes[j].Clone();
           j--;
           if (j < 0) j = scopes.Count - 1;
         } else {
-          selected.Add(scopes[scopes.Count - 1]);
+          selected[i] = scopes[scopes.Count - 1];
           scopes.RemoveAt(scopes.Count - 1);
         }
Index: /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2830)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -59,6 +60,6 @@
 
     public sealed override IExecutionSequence Apply() {
-      ScopeList scopes = new ScopeList(CurrentScope.SubScopes);
-      ScopeList selected = Select(scopes);
+      List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
+      IScope[] selected = Select(scopes);
 
       CurrentScope.SubScopes.Clear();
@@ -73,5 +74,5 @@
     }
 
-    protected abstract ScopeList Select(ScopeList scopes);
+    protected abstract IScope[] Select(List<IScope> scopes);
   }
 }
Index: /trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 2830)
@@ -44,5 +44,5 @@
     }
 
-    protected override ScopeList Select(ScopeList scopes) {
+    protected override IScope[] Select(List<IScope> scopes) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       bool copy = CopySelectedParameter.Value.Value;
@@ -51,5 +51,5 @@
       List<double> qualities = QualityParameter.ActualValue.Select(x => x.Value).ToList();
       int groupSize = GroupSizeParameter.ActualValue.Value;
-      ScopeList selected = new ScopeList();
+      IScope[] selected = new IScope[count];
 
       for (int i = 0; i < count; i++) {
@@ -65,7 +65,7 @@
 
         if (copy)
-          selected.Add((IScope)scopes[best].Clone());
+          selected[i] = (IScope)scopes[best].Clone();
         else {
-          selected.Add(scopes[best]);
+          selected[i] = scopes[best];
           scopes.RemoveAt(best);
           qualities.RemoveAt(best);
